/*
 * Copyright (C) Huawei Technologies Co., Ltd. 2023-2024. All rights reserved.
 * SPDX-License-Identifier: MIT
 */

#ifndef VATOMIC_CONFIG_SZ_RLX_H
#define VATOMIC_CONFIG_SZ_RLX_H
/* !!!Warning: File generated by tmplr; DO NOT EDIT.!!! */

#include <vsync/atomic/await.h>

#if defined(VATOMIC_ENABLE_ATOMIC_RLX)

    #define VATOMICSZ_READ
static inline vsize_t
vatomicsz_read(const vatomicsz_t *a)
{
    return vatomicsz_read_rlx(a);
}
    #define VATOMICSZ_READ_ACQ
static inline vsize_t
vatomicsz_read_acq(const vatomicsz_t *a)
{
    return vatomicsz_read_rlx(a);
}

    #define VATOMICSZ_WRITE
static inline void
vatomicsz_write(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_write_rlx(a, v);
}
    #define VATOMICSZ_WRITE_REL
static inline void
vatomicsz_write_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_write_rlx(a, v);
}

    #define VATOMICSZ_XCHG
static inline vsize_t
vatomicsz_xchg(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xchg_rlx(a, v);
}
    #define VATOMICSZ_XCHG_ACQ
static inline vsize_t
vatomicsz_xchg_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xchg_rlx(a, v);
}
    #define VATOMICSZ_XCHG_REL
static inline vsize_t
vatomicsz_xchg_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xchg_rlx(a, v);
}

    #define VATOMICSZ_CMPXCHG
static inline vsize_t
vatomicsz_cmpxchg(vatomicsz_t *a, vsize_t e, vsize_t v)
{
    return vatomicsz_cmpxchg_rlx(a, e, v);
}
    #define VATOMICSZ_CMPXCHG_ACQ
static inline vsize_t
vatomicsz_cmpxchg_acq(vatomicsz_t *a, vsize_t e, vsize_t v)
{
    return vatomicsz_cmpxchg_rlx(a, e, v);
}
    #define VATOMICSZ_CMPXCHG_REL
static inline vsize_t
vatomicsz_cmpxchg_rel(vatomicsz_t *a, vsize_t e, vsize_t v)
{
    return vatomicsz_cmpxchg_rlx(a, e, v);
}

    #define VATOMICSZ_GET_MAX
static inline vsize_t
vatomicsz_get_max(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_max_rlx(a, v);
}
    #define VATOMICSZ_GET_AND
static inline vsize_t
vatomicsz_get_and(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_and_rlx(a, v);
}
    #define VATOMICSZ_GET_OR
static inline vsize_t
vatomicsz_get_or(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_or_rlx(a, v);
}
    #define VATOMICSZ_GET_XOR
static inline vsize_t
vatomicsz_get_xor(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_xor_rlx(a, v);
}
    #define VATOMICSZ_GET_ADD
static inline vsize_t
vatomicsz_get_add(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_add_rlx(a, v);
}
    #define VATOMICSZ_GET_SUB
static inline vsize_t
vatomicsz_get_sub(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_sub_rlx(a, v);
}
    #define VATOMICSZ_MAX_GET
static inline vsize_t
vatomicsz_max_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_max_get_rlx(a, v);
}
    #define VATOMICSZ_AND_GET
static inline vsize_t
vatomicsz_and_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_and_get_rlx(a, v);
}
    #define VATOMICSZ_OR_GET
static inline vsize_t
vatomicsz_or_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_or_get_rlx(a, v);
}
    #define VATOMICSZ_XOR_GET
static inline vsize_t
vatomicsz_xor_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xor_get_rlx(a, v);
}
    #define VATOMICSZ_ADD_GET
static inline vsize_t
vatomicsz_add_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_add_get_rlx(a, v);
}
    #define VATOMICSZ_SUB_GET
static inline vsize_t
vatomicsz_sub_get(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_sub_get_rlx(a, v);
}
    #define VATOMICSZ_GET_MAX_ACQ
static inline vsize_t
vatomicsz_get_max_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_max_rlx(a, v);
}
    #define VATOMICSZ_GET_AND_ACQ
static inline vsize_t
vatomicsz_get_and_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_and_rlx(a, v);
}
    #define VATOMICSZ_GET_OR_ACQ
static inline vsize_t
vatomicsz_get_or_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_or_rlx(a, v);
}
    #define VATOMICSZ_GET_XOR_ACQ
static inline vsize_t
vatomicsz_get_xor_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_xor_rlx(a, v);
}
    #define VATOMICSZ_GET_ADD_ACQ
static inline vsize_t
vatomicsz_get_add_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_add_rlx(a, v);
}
    #define VATOMICSZ_GET_SUB_ACQ
static inline vsize_t
vatomicsz_get_sub_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_sub_rlx(a, v);
}
    #define VATOMICSZ_MAX_GET_ACQ
static inline vsize_t
vatomicsz_max_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_max_get_rlx(a, v);
}
    #define VATOMICSZ_AND_GET_ACQ
static inline vsize_t
vatomicsz_and_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_and_get_rlx(a, v);
}
    #define VATOMICSZ_OR_GET_ACQ
static inline vsize_t
vatomicsz_or_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_or_get_rlx(a, v);
}
    #define VATOMICSZ_XOR_GET_ACQ
static inline vsize_t
vatomicsz_xor_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xor_get_rlx(a, v);
}
    #define VATOMICSZ_ADD_GET_ACQ
static inline vsize_t
vatomicsz_add_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_add_get_rlx(a, v);
}
    #define VATOMICSZ_SUB_GET_ACQ
static inline vsize_t
vatomicsz_sub_get_acq(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_sub_get_rlx(a, v);
}
    #define VATOMICSZ_GET_MAX_REL
static inline vsize_t
vatomicsz_get_max_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_max_rlx(a, v);
}
    #define VATOMICSZ_GET_AND_REL
static inline vsize_t
vatomicsz_get_and_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_and_rlx(a, v);
}
    #define VATOMICSZ_GET_OR_REL
static inline vsize_t
vatomicsz_get_or_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_or_rlx(a, v);
}
    #define VATOMICSZ_GET_XOR_REL
static inline vsize_t
vatomicsz_get_xor_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_xor_rlx(a, v);
}
    #define VATOMICSZ_GET_ADD_REL
static inline vsize_t
vatomicsz_get_add_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_add_rlx(a, v);
}
    #define VATOMICSZ_GET_SUB_REL
static inline vsize_t
vatomicsz_get_sub_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_get_sub_rlx(a, v);
}
    #define VATOMICSZ_MAX_GET_REL
static inline vsize_t
vatomicsz_max_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_max_get_rlx(a, v);
}
    #define VATOMICSZ_AND_GET_REL
static inline vsize_t
vatomicsz_and_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_and_get_rlx(a, v);
}
    #define VATOMICSZ_OR_GET_REL
static inline vsize_t
vatomicsz_or_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_or_get_rlx(a, v);
}
    #define VATOMICSZ_XOR_GET_REL
static inline vsize_t
vatomicsz_xor_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_xor_get_rlx(a, v);
}
    #define VATOMICSZ_ADD_GET_REL
static inline vsize_t
vatomicsz_add_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_add_get_rlx(a, v);
}
    #define VATOMICSZ_SUB_GET_REL
static inline vsize_t
vatomicsz_sub_get_rel(vatomicsz_t *a, vsize_t v)
{
    return vatomicsz_sub_get_rlx(a, v);
}

    #define VATOMICSZ_GET_INC
static inline vsize_t
vatomicsz_get_inc(vatomicsz_t *a)
{
    return vatomicsz_get_inc_rlx(a);
}
    #define VATOMICSZ_INC_GET
static inline vsize_t
vatomicsz_inc_get(vatomicsz_t *a)
{
    return vatomicsz_inc_get_rlx(a);
}
    #define VATOMICSZ_GET_DEC
static inline vsize_t
vatomicsz_get_dec(vatomicsz_t *a)
{
    return vatomicsz_get_dec_rlx(a);
}
    #define VATOMICSZ_DEC_GET
static inline vsize_t
vatomicsz_dec_get(vatomicsz_t *a)
{
    return vatomicsz_dec_get_rlx(a);
}
    #define VATOMICSZ_GET_INC_ACQ
static inline vsize_t
vatomicsz_get_inc_acq(vatomicsz_t *a)
{
    return vatomicsz_get_inc_rlx(a);
}
    #define VATOMICSZ_INC_GET_ACQ
static inline vsize_t
vatomicsz_inc_get_acq(vatomicsz_t *a)
{
    return vatomicsz_inc_get_rlx(a);
}
    #define VATOMICSZ_GET_DEC_ACQ
static inline vsize_t
vatomicsz_get_dec_acq(vatomicsz_t *a)
{
    return vatomicsz_get_dec_rlx(a);
}
    #define VATOMICSZ_DEC_GET_ACQ
static inline vsize_t
vatomicsz_dec_get_acq(vatomicsz_t *a)
{
    return vatomicsz_dec_get_rlx(a);
}
    #define VATOMICSZ_GET_INC_REL
static inline vsize_t
vatomicsz_get_inc_rel(vatomicsz_t *a)
{
    return vatomicsz_get_inc_rlx(a);
}
    #define VATOMICSZ_INC_GET_REL
static inline vsize_t
vatomicsz_inc_get_rel(vatomicsz_t *a)
{
    return vatomicsz_inc_get_rlx(a);
}
    #define VATOMICSZ_GET_DEC_REL
static inline vsize_t
vatomicsz_get_dec_rel(vatomicsz_t *a)
{
    return vatomicsz_get_dec_rlx(a);
}
    #define VATOMICSZ_DEC_GET_REL
static inline vsize_t
vatomicsz_dec_get_rel(vatomicsz_t *a)
{
    return vatomicsz_dec_get_rlx(a);
}

    #define VATOMICSZ_MAX
static inline void
vatomicsz_max(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_max_rlx(a, v);
}
    #define VATOMICSZ_AND
static inline void
vatomicsz_and(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_and_rlx(a, v);
}
    #define VATOMICSZ_OR
static inline void
vatomicsz_or(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_or_rlx(a, v);
}
    #define VATOMICSZ_XOR
static inline void
vatomicsz_xor(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_xor_rlx(a, v);
}
    #define VATOMICSZ_ADD
static inline void
vatomicsz_add(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_add_rlx(a, v);
}
    #define VATOMICSZ_SUB
static inline void
vatomicsz_sub(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_sub_rlx(a, v);
}
    #define VATOMICSZ_MAX_REL
static inline void
vatomicsz_max_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_max_rlx(a, v);
}
    #define VATOMICSZ_AND_REL
static inline void
vatomicsz_and_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_and_rlx(a, v);
}
    #define VATOMICSZ_OR_REL
static inline void
vatomicsz_or_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_or_rlx(a, v);
}
    #define VATOMICSZ_XOR_REL
static inline void
vatomicsz_xor_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_xor_rlx(a, v);
}
    #define VATOMICSZ_ADD_REL
static inline void
vatomicsz_add_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_add_rlx(a, v);
}
    #define VATOMICSZ_SUB_REL
static inline void
vatomicsz_sub_rel(vatomicsz_t *a, vsize_t v)
{
    vatomicsz_sub_rlx(a, v);
}

    #define VATOMICSZ_INC
static inline void
vatomicsz_inc(vatomicsz_t *a)
{
    vatomicsz_inc_rlx(a);
}
    #define VATOMICSZ_DEC
static inline void
vatomicsz_dec(vatomicsz_t *a)
{
    vatomicsz_dec_rlx(a);
}
    #define VATOMICSZ_INC_REL
static inline void
vatomicsz_inc_rel(vatomicsz_t *a)
{
    vatomicsz_inc_rlx(a);
}
    #define VATOMICSZ_DEC_REL
static inline void
vatomicsz_dec_rel(vatomicsz_t *a)
{
    vatomicsz_dec_rlx(a);
}

#endif
#endif
